using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace WinFormUtility
{

    public class GraphicsPanel : System.Windows.Forms.Panel
    {
        private Device pDevice;
        private Model model;

        public GraphicsPanel()
        {
            pDevice = null;
            model = null;
        }

        // initialize the DirectX pDevice
        public void InitializeGraphics()
        {
            PresentParameters presentParams = new PresentParameters();
            presentParams.Windowed = true;
            presentParams.SwapEffect = SwapEffect.Discard;

            pDevice = new Device(0, DeviceType.Hardware, this, CreateFlags.SoftwareVertexProcessing, presentParams);

            pDevice.RenderState.Lighting = false;
            pDevice.RenderState.ShadeMode = ShadeMode.Gouraud;
            pDevice.RenderState.ZBufferEnable = false;
            pDevice.RenderState.CullMode = Cull.CounterClockwise;
        }

        // Set the model to this model, p_ to signify a passed in parameter.
        public void setModel(Model p_model)
        {
            this.model = p_model;

        }

        // Call this every timer tick to refresh the D3D display
        public void Draw()
        {
            
            pDevice.Clear(ClearFlags.Target, Color.SkyBlue.ToArgb(), 0.0f, 0);
            pDevice.BeginScene();

           // model.Draw(pDevice);

            pDevice.EndScene();
            pDevice.Present();

        }

        // Accessor to retrieve the pDevice
        public Device getDevice()
        {
            return pDevice;
        }

        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            // allow normal control painting to occur first
            base.OnPaint(e);
        }

    }   // End GraphicsPanel Class
}   // End WinForm Utility Namespace

   

